﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using System.Data.SqlClient;
using Negocios;
using System.Data.OleDb;

namespace DAOs
{
    public class DAO
    {

        public static string BANCO = "DAOs.Properties.Settings.BancoAVA03ConnectionString";
        public static string ACCESS = "DAOs.Properties.Settings.BancoMAConnectionString";

        private SqlConnection getSqlConnection(string str)
        {
            string conexao = ConfigurationManager.ConnectionStrings[str].ConnectionString;
            return new SqlConnection(conexao);
        }

        public void InsertCliente(Cliente cliente)
        {
            string query = @"
                            INSERT INTO [dbo].[clientes]
                                       ([cliente_id]
                                       ,[nome]
                                       ,[sobrenome]
                                       ,[rua]
                                       ,[cidade]
                                       ,[estado]
                                       ,[cep])
                                 VALUES
                                       (@cliente_id
                                       ,@nome
                                       ,@sobrenome
                                       ,@rua
                                       ,@cidade
                                       ,@estado
                                       ,@cep)";

            SqlParameter p1 = new SqlParameter("cliente_id", cliente.Id);
            SqlParameter p2 = new SqlParameter("nome", cliente.Nome);
            SqlParameter p3 = new SqlParameter("sobrenome", cliente.Sobrenome);
            SqlParameter p4 = new SqlParameter("rua", cliente.Rua);
            SqlParameter p5 = new SqlParameter("cidade", cliente.Cidade);
            SqlParameter p6 = new SqlParameter("estado", cliente.Estado);
            SqlParameter p7 = new SqlParameter("cep", cliente.Cep);

            SqlConnection conn = getSqlConnection(BANCO);
            SqlCommand comando = conn.CreateCommand();

            comando.CommandText = query;
            comando.Parameters.Add(p1);
            comando.Parameters.Add(p2);
            comando.Parameters.Add(p3);
            comando.Parameters.Add(p4);
            comando.Parameters.Add(p5);
            comando.Parameters.Add(p6);
            comando.Parameters.Add(p7);

            conn.Open();
            comando.ExecuteNonQuery();
            conn.Close();
        }

        public List<Cliente> buscarClientes()
        {
            string query = @"select * from [dbo].[clientes]";

            SqlConnection conn = getSqlConnection(BANCO);

            SqlCommand comando = conn.CreateCommand();
            comando.CommandText = query;

            conn.Open();
            SqlDataReader reader = comando.ExecuteReader();
            List<Cliente> list = retornarClientes(reader);
            conn.Close();

            return list;
        }

        public List<Cliente> buscarClientesAccess()
        {
            string query = "select * from [clientes]";
            
            OleDbConnection conn = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=|DataDirectory|\BancoMA.mdb");
            OleDbCommand comando = conn.CreateCommand();
            comando.CommandText = query;

            conn.Open();
            OleDbDataReader reader = comando.ExecuteReader();
            List<Cliente> list = retornarClientes(reader);
            conn.Close();

            return list;
        }

        public Cliente buscarCliente(string id)
        {
            string query = @"select * from [dbo].[clientes] where cliente_id = @id";

            SqlConnection conn = getSqlConnection(BANCO);
            SqlCommand comando = conn.CreateCommand();
            comando.CommandText = query;
            SqlParameter p = new SqlParameter("id", id);
            comando.Parameters.Add(p);

            conn.Open();
            SqlDataReader reader = comando.ExecuteReader();
            Cliente cliente = retornarCliente(reader);
            conn.Close();

            return cliente;
        }

        private List<Cliente> retornarClientes(SqlDataReader reader)
        {
            List<Cliente> list = new List<Cliente>();

            while (reader.Read())
            {
                list.Add(new Cliente(reader));
            }

            return list;
        }

        private List<Cliente> retornarClientes(OleDbDataReader reader)
        {
            List<Cliente> list = new List<Cliente>();

            while (reader.Read())
            {
                list.Add(new Cliente(reader));
            }

            return list;
        }

        private Cliente retornarCliente(SqlDataReader reader)
        {
            Cliente cliente = null;

            while (reader.Read())
            {
                cliente = new Cliente(reader);
            }

            return cliente;
        }
        

    }
}
